apiVersion: apps/v1
kind: Deployment
metadata:
  name: "{{  .Chart.Name }}-deployment"
  labels:
    chart: '{{ .Chart.Name }}-{{ .Chart.Version | replace "+" "_" }}'
spec:
  replicas: {{ .Values.replicaCount }}
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxUnavailable: 0
      maxSurge: 1
  selector:
    matchLabels:
      app: "{{  .Chart.Name }}-selector"
      version: "current"
      type: "{{  .Values.type }}"
  revisionHistoryLimit: {{ .Values.revisionHistoryLimit }}
  template:
    metadata:
      labels:
        app: "{{  .Chart.Name }}-selector"
        version: "current"
        type: "{{  .Values.type }}"
    spec:
      {{- if .Values.type }}
      affinity:
        nodeAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
            nodeSelectorTerms:
            - matchExpressions:
              - key: "type"
                operator: "In"
                values:
                - {{  .Values.type }}
      {{- end }}
      containers:
      - name: "{{  .Chart.Name  }}"
        image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
        imagePullPolicy: {{ .Values.image.pullPolicy }}
        ports:
        - containerPort: {{ .Values.service.servicePort}}
        {{- if .Values.image.produccion }}
        {{- if .Values.image.produccion.enabled }}
        resources:
          requests:
            cpu: "{{ .Values.image.resources.requests.cpu }}"
            memory: "{{ .Values.image.resources.requests.memory }}"
        {{- else }}
        resources:
          requests:
            cpu: "30m"
            memory: "100Mi"
        {{- end }}
        {{- else }}
        resources:
          requests:
            cpu: "30m"
            memory: "100Mi"
        {{- end }}
        env:
          - name: PORT
            value : "{{ .Values.service.servicePort }}"           
            {{- range $key, $value := .Values.configmap }}
          - name: {{ $key }}
            value : "{{ $value }}"
            {{- end }}            
          {{- range $key, $value := $.Values.globalSecrets }}
          - name: {{ $key }}
            valueFrom:
              secretKeyRef:
                name: {{ $value }}
                key: {{ $key }}
          {{- end }}              
#--
   {{- if .Values.contenedorpdf }}
      - name: "{{  .Values.contenedorpdf.name  }}"
        image: "{{ .Values.contenedorpdf.repository }}:{{ .Values.contenedorpdf.tag }}"
        imagePullPolicy: IfNotPresent
        ports:
          - containerPort: {{  .Values.contenedorpdf.port  }}
        resources:
          requests:
            cpu: "{{  .Values.contenedorpdf.cpu  }}"
            memory: "{{  .Values.contenedorpdf.memory  }}"
  {{- end }}
#--
        {{- if .Values.image.livenessProbe }}
        livenessProbe:
{{ toYaml .Values.image.livenessProbe | indent 30 }}
        {{- end }}
        {{- if .Values.image.readinessProbe }}
        readinessProbe:
{{ toYaml .Values.image.readinessProbe | indent 30 }}
        {{- end }}
